'use strict';









var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _prettyFormat = require('pretty-format');var _prettyFormat2 = _interopRequireDefault(_prettyFormat);
var _leven = require('leven');var _leven2 = _interopRequireDefault(_leven);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const BULLET = _chalk2.default.bold('\u25cf'); /**
                                                * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                *
                                                * This source code is licensed under the BSD-style license found in the
                                                * LICENSE file in the root directory of this source tree. An additional grant
                                                * of patent rights can be found in the PATENTS file in the same directory.
                                                *
                                                * 
                                                */const DEPRECATION = `${BULLET} Deprecation Warning`;const ERROR = `${BULLET} Validation Error`;const WARNING = `${BULLET} Validation Warning`;const format = value => typeof value === 'function' ? value.toString() : (0, _prettyFormat2.default)(value, { min: true });

class ValidationError extends Error {



  constructor(name, message, comment) {
    super();
    comment = comment ? '\n\n' + comment : '\n';
    this.name = '';
    this.message = _chalk2.default.red(_chalk2.default.bold(name) + ':\n\n' + message + comment);
    Error.captureStackTrace(this, () => {});
  }}


const logValidationWarning = (
name,
message,
comment) =>
{
  comment = comment ? '\n\n' + comment : '\n';
  console.warn(_chalk2.default.yellow(_chalk2.default.bold(name) + ':\n\n' + message + comment));
};

const createDidYouMeanMessage = (
unrecognized,
allowedOptions) =>
{
  const suggestion = allowedOptions.find(option => {
    const steps = (0, _leven2.default)(option, unrecognized);
    return steps < 3;
  });

  return suggestion ? `Did you mean ${_chalk2.default.bold(format(suggestion))}?` : '';
};

module.exports = {
  DEPRECATION,
  ERROR,
  ValidationError,
  WARNING,
  createDidYouMeanMessage,
  format,
  logValidationWarning };